'use strict'


const Hapi = require('@hapi/hapi')
const moment = require('moment')
const config = require('./config')
const livedata = require('./Livedata')
const dateFormat = require('dateformat')
var cronJob = require('cron').CronJob
const fs = require('fs');
var CronJob = require('cron').CronJob;
const consumer = require('./rabbitmq');

const server = Hapi.server({
    port: 9002,
    host: '172.16.16.35',
    // host: '0.0.0.0',
	routes: {
        cors: {
            origin: ['*'],
            additionalHeaders: ['cache-control', 'x-requested-with']
        }
    },
})

global.sensorid = {}
global.sensors = []
global.fftsensors = []

global.machinesensormapping = {} 
global.threshold = {}
global.temperature_threshold = {}
global.max_threshold = {}

global.sensorflags ={} // for start and stop 1111 flags
global.sensorarray ={} // for sensor data

server.route({
    path:'/welcome',
    method: 'GET',
    handler: (req,h)=>{
        return "Welcome!"
    }
})


server.route({
    path:'/data',
    method:'POST',
    handler:async (req,h)=>{
       console.log(`received data: `, req.payload)
       let d = String(dateFormat( new Date(Date.now()),'yyyy-mm-dd HH:MM:ss')) 
       //console.log("timee",d)
       let created_at = new Date(d).toISOString().slice(0,-5) + 'Z'
       for(let item of req.payload){
           item.created_at = created_at
       }
        livedata.livedatapostnew(req.payload)
       return 1
    }
})

async function readmachinethreshold(){
	let val = {}
	
	
	const accounts = () => fs.readFileSync('machine_threshold.txt', { endoding: 'utf8'})
	var data = accounts()
	if(data.length > 0){
		
	const accRead = JSON.parse(accounts())
	global.machinesensormapping = accRead.sensors
    global.threshold = accRead.threshold
    global.max_threshold = accRead.max_threshold
    global.temperature_threshold = accRead.temperature_threshold
	console.log(accRead);
	
	
	   return accRead;
	}else{
		//return {};
	}
}


server.route({
	
    path:'/fft',
    method: 'GET',
   handler: async(req,reply)=>{
	  
	  
	  return global.fftsensors;
    }
})

readmachinethreshold()

server.start()
console.log("Server is started at port: ", server.info.uri)

new CronJob('*/1 * * * * *', async function(){
	consumer.getthresholddata();
},null,true, '')

process.on("unhandledRejection",(err)=>{
    console.log('error', err)
    process.exit(1)
})

